# Ensure that .env exists before running
# docker compose up -d --build --force-recreate
# docker compose down --rmi all --remove-orphans

version: '3.7'
services:
  postgres:
    image: postgres:${PG_VERSION:-16}-alpine
    container_name: 'postgres-${ENVIRONMENT:-development}'
    hostname: 'db'
    networks:
      - compose_network
    environment:
      TZ: "${TZ:-UTC}"
      POSTGRES_USER: "${DB_USER}"
      POSTGRES_PASSWORD: "${DB_PASS}"
    volumes:
      - postgres:/var/lib/postgresql/data
    restart: unless-stopped
    security_opt:
      - no-new-privileges:true
  
  solidus:
    depends_on:
      - postgres
    build:
      context: .
      args:
        RUBY_VERSION: ${RUBY_VERSION:-3.3.0}
        APP_USER: ${APP_USER:-solidus}
        PG_VERSION: ${PG_VERSION:-16}
        NODE_VERSION: ${NODE_VERSION:-20}
    container_name: 'solidus-${ENVIRONMENT:-development}'
    hostname: 'solidus'
    ports:
      - "${APP_PORT:-3000}:3000"
    networks:
      - compose_network
    environment:
      TZ: "${TZ:-UTC}"
      DB_USERNAME: "${DB_USER}"
      DB_PASSWORD: "${DB_PASS}"
      DB_POSTGRES_HOST: postgres
      ACTIVE_STORAGE_VARIANT_PROCESSOR: "vips"
      RAILS_ENV: development
      PAYPAL_CLIENT_ID: "${PAYPAL_CLIENT_ID}"
      PAYPAL_CLIENT_SECRET: "${PAYPAL_CLIENT_SECRET}"
      SES_FROM_ADDRESS: "${SES_FROM_ADDRESS:-noreply@acivildawn.com}"
      SES_AWS_ACCESS_KEY_ID: "${SES_AWS_ACCESS_KEY_ID}"
      SES_AWS_SECRET_ACCESS_KEY: "${SES_AWS_SECRET_ACCESS_KEY}"
    restart: unless-stopped
    tmpfs:
      - /tmp
    security_opt:
      - no-new-privileges:true
    stop_grace_period: 30s
    stop_signal: SIGTERM

networks:
  compose_network:
    name: 'solidus-${ENVIRONMENT:-development}'

volumes:
  postgres:

# .env template
# ENVIRONMENT=                Appended to container name
# PG_VERSION=                 Postgres version (tag is assumed to be alpine here)
# APP_PORT=                   default 8065 - The external tcp port to connect to this server
# TZ=                         default America/Los_Angeles - The timezone
# DB_USER=                    The database username
# DB_PASS=                    The database password
# APP_USER=                   The user which will be running the application inside the container
# RUBY_VERSION=               Version of Ruby to install in the Dockerfile
# NODE_VERSION=               Version of Node to install in the Dockerfile
# BUNDLER_VERSION=            Version of Bundler to install in the Dockerfile
# PAYPAL_CLIENT_ID=           Paypal client ID from https://developer.paypal.com/
# PAYPAL_CLIENT_SECRET=       Paypal client secret from https://developer.paypal.com/
# SES_FROM_ADDRESS=           Email address to send email from (default: noreply@acivildawn.com)
# SES_AWS_ACCESS_KEY_ID=      AWS SES credentials (optional, you must enable email in devel in config/environments/development.rb)
# SES_AWS_SECRET_ACCESS_KEY=  AWS SES credentials (optional, you must enable email in devel in config/environments/development.rb)
